library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity dRegFile is
    port (CLK  : in std_logic;
          WE   : in std_logic;
          ADDR : in std_logic_vector(3 downto 0);
			 rst   : in STD_LOGIC;
          DI   : in STD_LOGIC;
          DO   : out STD_LOGIC);
end dRegFile;

architecture Behavioral of dRegFile is
    type ram_type is array (7 downto 0) of STD_LOGIC;
    signal RAM: ram_type;
begin

	process(rst)
	begin 
		if (rst = '1') then 
			RAM(0) <= '0';
			RAM(1) <= '0';
			RAM(2) <= '0';
			RAM(3) <= '0';
			RAM(4) <= '0';
			RAM(5) <= '0';
			RAM(6) <= '0';
			RAM(7) <= '0';
		end if; 
	end process; 

    process (CLK)
    begin
        if CLK'event and CLK = '1' then
                if WE = '1' then
                    RAM(conv_integer(ADDR)) <= DI;
                end if;
                DO <= RAM(conv_integer(ADDR)) ;

        end if;
    end process;

end Behavioral;

					