library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity tagRegisterFile is
    port (CLK  : in std_logic;
          WE   : in std_logic;
          ADDR : in std_logic_vector(3 downto 0);
          DI   : in std_logic_vector(7 downto 0);
          DO   : out std_logic_vector(7 downto 0));
end tagRegisterFile;

architecture Behavioral of tagRegisterFile is
    type ram_type is array (7 downto 0) of std_logic_vector (7 downto 0);
    signal RAM: ram_type;
begin

    process (CLK)
    begin
        if CLK'event and CLK = '1' then
                if WE = '1' then
                    RAM(conv_integer(ADDR)) <= DI;
                end if;
                DO <= RAM(conv_integer(ADDR)) ;
        end if;
    end process;

end Behavioral;

					